searchNodes=[{"doc":"Runs the linter. &gt; mix recode [options] [wildcard] Without a wildcard argument the inputs value from the config is used. Without the option --config file the config file .recode.exs is used. A default .recode.exs can be generated with mix recode.gen.config . Command line Option --autocorrect , --no-autocorrect - Activates/deactivates autocrrection. Overwrites the corresponding value in the configuration. --config - specifies an alternative config file. --dry , --no-dry - Activates/deactivates the dry mode. No file is overwritten in dry mode. Overwrites the corresponding value in the configuration. --verbose , --no-verbose - Activate/deactivates the verbose mode. Overwrites the corresponding value in the configuration.","ref":"Mix.Tasks.Recode.html","title":"Mix.Tasks.Recode","type":"task"},{"doc":"Generates a new config for Recode. Writes the file .recode.exs in the root directory of the mix project. The default config: alias Recode.Task [ # Can also be set/reset with &quot;--autocorrect&quot;/&quot;--no-autocorrect&quot;. autocorrect : true , # With &quot;--dry&quot; no changes will be writen to the files. # Can also be set/reset with &quot;--dry&quot;/&quot;--no-dry&quot;. # If dry is true then verbose is also active. dry : false , # Can also be set/reset with &quot;--verbose&quot;/&quot;--no-verbose&quot;. verbose : false , inputs : [ &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] , formatter : { Recode.Formatter , [ ] } , tasks : [ { Task.AliasExpansion , [ ] } , { Task.AliasOrder , [ ] } , { Task.PipeFunOne , [ ] } , { Task.SinglePipe , [ ] } , { Task.Specs , [ only : :visible , exclude : &quot;test/**/*.{ex,exs}&quot; ] } , { Task.TestFileExt , [ ] } ] ]","ref":"Mix.Tasks.Recode.Gen.Config.html","title":"Mix.Tasks.Recode.Gen.Config","type":"task"},{"doc":"A mix task to rename functions. mix recode.rename Module.name[/arity] new_name This mix task overwrite the definition and all calls of the given function with the new_name . If the arity is given to Module.name only functions with the corresponding arity will be rewritten. Examples mix recode.rename MyApp.hello say_hello mix recode.rename MyApp.SomeMoudle.do_it/2 make Switchtes --config - specifies an alternative config file. --dry , --no-dry - Activates/deactivates the dry mode. No file is overwritten in dry mode. Overwrites the corresponding value in the configuration. --verbose , --no-verbose - Activate/deactivates the verbose mode. Overwrites the corresponding value in the configuration.","ref":"Mix.Tasks.Recode.Rename.html","title":"Mix.Tasks.Recode.Rename","type":"task"},{"doc":"A linter with autocorrection and a refactoring tool.","ref":"Recode.html","title":"Recode","type":"module"},{"doc":"This module provides functions to manipulate the AST.","ref":"Recode.AST.html","title":"Recode.AST","type":"module"},{"doc":"Returns the infos from an AST representing an alias expression. The function returns 3-tuple containing the alias, the multi part and the :as . Examples iex&gt; ast = quote do ...&gt; alias Foo.Bar ...&gt; end iex&gt; alias_info ( ast ) { Foo.Bar , [ ] , nil } iex&gt; ast = quote do ...&gt; alias Foo . { Bar , Baz } ...&gt; end iex&gt; alias_info ( ast ) { Foo , [ Bar , Baz ] , nil } iex&gt; ast = quote do ...&gt; alias Foo , as : Baz ...&gt; end iex&gt; alias_info ( ast ) { Foo , [ ] , Baz }","ref":"Recode.AST.html#alias_info/1","title":"Recode.AST.alias_info/1","type":"function"},{"doc":"Concatinates the aliases of an :__aliases__ tuple. Examples iex&gt; aliases_concat ( { :__aliases__ , [ ] , [ :Alpha , :Bravo ] } ) Alpha.Bravo","ref":"Recode.AST.html#aliases_concat/1","title":"Recode.AST.aliases_concat/1","type":"function"},{"doc":"Returns the newlines value from meta[:end_of_expression] , or nil .","ref":"Recode.AST.html#get_newlines/1","title":"Recode.AST.get_newlines/1","type":"function"},{"doc":"Returns a mfa -tuple for the given . -call.","ref":"Recode.AST.html#mfa/1","title":"Recode.AST.mfa/1","type":"function"},{"doc":"Converts AST representing a name to a string. This function suppresses the prfix &quot;Elixir.&quot; . Examples iex&gt; name ( [ Recode , AST ] ) &quot;Recode.AST&quot; iex&gt; name ( Recode.AST ) &quot;Recode.AST&quot;","ref":"Recode.AST.html#name/1","title":"Recode.AST.name/1","type":"function"},{"doc":"Puts the given value newlines under the key nevlines in meta[:end_of_expression] .","ref":"Recode.AST.html#put_newlines/2","title":"Recode.AST.put_newlines/2","type":"function"},{"doc":"Update a function call. The keyword list updates can have the keys name , meta and args . Examples iex&gt; ast = quote do ...&gt; foo ( x ) ...&gt; end iex&gt; update_call ( ast , name : :bar ) { :bar , [ ] , [ { :x , [ ] , Recode.ASTTest } ] }","ref":"Recode.AST.html#update_call/2","title":"Recode.AST.update_call/2","type":"function"},{"doc":"Updates the AST representing a definition. The keyword list updates can have the keys name , meta and args . Examples iex&gt; ast = quote do ...&gt; def foo ( x ) , do : x ...&gt; end iex&gt; update_definition ( ast , name : :bar ) { :def , [ context : Recode.ASTTest , import : Kernel ] , [ { :bar , [ context : Recode.ASTTest ] , [ { :x , [ ] , Recode.ASTTest } ] } , [ do : { :x , [ ] , Recode.ASTTest } ] ] } iex&gt; update_definition ( ast , meta : [ ] ) { :def , [ ] , [ { :foo , [ context : Recode.ASTTest ] , [ { :x , [ ] , Recode.ASTTest } ] } , [ do : { :x , [ ] , Recode.ASTTest } ] ] } iex&gt; update_definition ( ast , args : [ { :y , [ ] , Recode.ASTTest } ] , meta : [ ] ) { :def , [ ] , [ { :foo , [ context : Recode.ASTTest ] , [ { :y , [ ] , Recode.ASTTest } ] } , [ do : { :x , [ ] , Recode.ASTTest } ] ] }","ref":"Recode.AST.html#update_definition/2","title":"Recode.AST.update_definition/2","type":"function"},{"doc":"Update a dotted function call. Examples iex&gt; ast = quote do ...&gt; Foo . foo ( x ) ...&gt; end iex&gt; update_dot_call ( ast , name : :bar ) { { :. , [ ] , [ { :__aliases__ , [ alias : false ] , [ :Foo ] } , :bar ] } , [ ] , [ { :x , [ ] , Recode.ASTTest } ] }","ref":"Recode.AST.html#update_dot_call/2","title":"Recode.AST.update_dot_call/2","type":"function"},{"doc":"Updates a spec. The keyword list updates can have the keys name , meta , args and return . Examples iex&gt; ast = quote do ...&gt; @spec foo ( integer ( ) ) :: integer ( ) ...&gt; end { : @ , [ context : Recode.ASTTest , import : Kernel ] , [ { :spec , [ context : Recode.ASTTest ] , [ { :&quot;::&quot; , [ ] , [ { :foo , [ ] , [ { :integer , [ ] , [ ] } ] } , { :integer , [ ] , [ ] } ] } ] } ] } iex&gt; update_spec ( ast , meta : [ ] , name : :bar , return : { :term , [ ] , [ ] } ) { : @ , [ ] , [ { :spec , [ context : Recode.ASTTest ] , [ { :&quot;::&quot; , [ ] , [ { :bar , [ ] , [ { :integer , [ ] , [ ] } ] } , { :term , [ ] , [ ] } ] } ] } ] }","ref":"Recode.AST.html#update_spec/2","title":"Recode.AST.update_spec/2","type":"function"},{"doc":"This module reads the Recode configuration.","ref":"Recode.Config.html","title":"Recode.Config","type":"module"},{"doc":"","ref":"Recode.Config.html#read/1","title":"Recode.Config.read/1","type":"function"},{"doc":"","ref":"Recode.Config.html#t:config/0","title":"Recode.Config.config/0","type":"type"},{"doc":"This module provides functions to traverse an AST with a %Context{} . Examples The following example shows the %Context{} for the definition of MyApp.Bar.bar/1 . iex&gt; alias Recode . { Source , Context } ...&gt; &quot;&quot;&quot; ...&gt; defmodule MyApp.Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; ...&gt; defmodule MyApp.Bar do ...&gt; alias MyApp.Foo ...&gt; ...&gt; def bar(x) do ...&gt; {Foo.foo(), x} ...&gt; end ...&gt; end ...&gt; &quot;&quot;&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . zipper ( ) ...&gt; |&gt; Context . traverse ( nil , fn ...&gt; zipper , context , nil -&gt; ...&gt; case context . definition do ...&gt; { { :def , :bar , 1 } , _meta } -&gt; { zipper , context , context } ...&gt; _def -&gt; { zipper , context , nil } ...&gt; end ...&gt; zipper , context , acc -&gt; ...&gt; { zipper , context , acc } ...&gt; end ) ...&gt; |&gt; elem ( 1 ) % Context { aliases : [ { MyApp.Foo , [ trailing_comments : [ ] , leading_comments : [ ] , end_of_expression : [ newlines : 2 , line : 6 , column : 18 ] , line : 6 , column : 3 ] , nil } ] , assigns : %{ } , definition : { { :def , :bar , 1 } , [ trailing_comments : [ ] , leading_comments : [ ] , do : [ line : 8 , column : 14 ] , end : [ line : 10 , column : 3 ] , line : 8 , column : 3 ] } , imports : [ ] , module : { MyApp.Bar , [ trailing_comments : [ ] , leading_comments : [ ] , do : [ line : 5 , column : 21 ] , end : [ line : 11 , column : 1 ] , line : 5 , column : 1 ] } , requirements : [ ] , usages : [ ] }","ref":"Recode.Context.html","title":"Recode.Context","type":"module"},{"doc":"Assigns the given value under key to the context .","ref":"Recode.Context.html#assign/3","title":"Recode.Context.assign/3","type":"function"},{"doc":"Merges the given map to the assigns of the context .","ref":"Recode.Context.html#assigns/2","title":"Recode.Context.assigns/2","type":"function"},{"doc":"Returns true if definition satisfies the assumption.","ref":"Recode.Context.html#definition?/2","title":"Recode.Context.definition?/2","type":"function"},{"doc":"Returns true if @doc is available and not set to @doc false .","ref":"Recode.Context.html#doc?/1","title":"Recode.Context.doc?/1","type":"function"},{"doc":"Returns true if @doc false .","ref":"Recode.Context.html#doc?/2","title":"Recode.Context.doc?/2","type":"function"},{"doc":"Expands the module alias for the given mfa .","ref":"Recode.Context.html#expand_mfa/2","title":"Recode.Context.expand_mfa/2","type":"function"},{"doc":"Returns true if an impl is available.","ref":"Recode.Context.html#impl?/1","title":"Recode.Context.impl?/1","type":"function"},{"doc":"Returns the current module of a context.","ref":"Recode.Context.html#module/1","title":"Recode.Context.module/1","type":"function"},{"doc":"Returns true if @moduledoc is available and not set to @moduledoc false .","ref":"Recode.Context.html#moduledoc?/1","title":"Recode.Context.moduledoc?/1","type":"function"},{"doc":"Returns true if @moduledoc false .","ref":"Recode.Context.html#moduledoc?/2","title":"Recode.Context.moduledoc?/2","type":"function"},{"doc":"Returns true if a spec is available.","ref":"Recode.Context.html#spec?/1","title":"Recode.Context.spec?/1","type":"function"},{"doc":"Traverses the given zipper and applies fun on each node. The fun gets the current zipper and context as arguments.","ref":"Recode.Context.html#traverse/2","title":"Recode.Context.traverse/2","type":"function"},{"doc":"Traverses the given zipper with an acc and applies fun on each node.","ref":"Recode.Context.html#traverse/3","title":"Recode.Context.traverse/3","type":"function"},{"doc":"","ref":"Recode.Context.html#t:t/0","title":"Recode.Context.t/0","type":"type"},{"doc":"","ref":"Recode.Context.html#t:zipper/0","title":"Recode.Context.zipper/0","type":"type"},{"doc":"This module provides helper functions to work with debug info.","ref":"Recode.DebugInfo.html","title":"Recode.DebugInfo","type":"module"},{"doc":"","ref":"Recode.DebugInfo.html#expand_mfa/3","title":"Recode.DebugInfo.expand_mfa/3","type":"function"},{"doc":"This module provides the information from .formatter.exs .","ref":"Recode.DotFormatter.html","title":"Recode.DotFormatter","type":"module"},{"doc":"Returns the option inputs from the .formatter.exs .","ref":"Recode.DotFormatter.html#inputs/0","title":"Recode.DotFormatter.inputs/0","type":"function"},{"doc":"Returns the option locals_without_parens from the .formatter.exs .","ref":"Recode.DotFormatter.html#locals_without_parens/0","title":"Recode.DotFormatter.locals_without_parens/0","type":"function"},{"doc":"Returns the options from the .formatter.exs .","ref":"Recode.DotFormatter.html#opts/0","title":"Recode.DotFormatter.opts/0","type":"function"},{"doc":"The default formatter and the formatter bebaviour.","ref":"Recode.Formatter.html","title":"Recode.Formatter","type":"behaviour"},{"doc":"","ref":"Recode.Formatter.html#format/3","title":"Recode.Formatter.format/3","type":"function"},{"doc":"","ref":"Recode.Formatter.html#c:format/3","title":"Recode.Formatter.format/3","type":"callback"},{"doc":"","ref":"Recode.Formatter.html#format/4","title":"Recode.Formatter.format/4","type":"function"},{"doc":"","ref":"Recode.Formatter.html#c:format/4","title":"Recode.Formatter.format/4","type":"callback"},{"doc":"This module provides IO functions and contains the color schema for Recode .","ref":"Recode.IO.html","title":"Recode.IO","type":"module"},{"doc":"Similar to write/1 , but adds a newline at the end.","ref":"Recode.IO.html#puts/1","title":"Recode.IO.puts/1","type":"function"},{"doc":"See IO.ANSI.reverse/0 .","ref":"Recode.IO.html#reverse/0","title":"Recode.IO.reverse/0","type":"function"},{"doc":"See IO.ANSI.reverse_off/0 .","ref":"Recode.IO.html#reverse_off/0","title":"Recode.IO.reverse_off/0","type":"function"},{"doc":"Formats a chardata-like argument by converting named ANSI sequences into actual ANSI codes and writes it to :stdio .","ref":"Recode.IO.html#write/1","title":"Recode.IO.write/1","type":"function"},{"doc":"","ref":"Recode.IO.html#t:chardata/0","title":"Recode.IO.chardata/0","type":"type"},{"doc":"","ref":"Recode.IO.html#t:color/0","title":"Recode.IO.color/0","type":"type"},{"doc":"An Issue struct to track findings by the chechers.","ref":"Recode.Issue.html","title":"Recode.Issue","type":"module"},{"doc":"","ref":"Recode.Issue.html#new/4","title":"Recode.Issue.new/4","type":"function"},{"doc":"","ref":"Recode.Issue.html#t:t/0","title":"Recode.Issue.t/0","type":"type"},{"doc":"The %Project{} contains all Recode.Sources of a project.","ref":"Recode.Project.html","title":"Recode.Project","type":"module"},{"doc":"Returns conflicts between sources. Sources with the same path have a conflict.","ref":"Recode.Project.html#conflicts/1","title":"Recode.Project.conflicts/1","type":"function"},{"doc":"Counts the items of the given type in the project . The type :sources returns the count for all sources in the project, including scripts. The type :scripts returns the count of all sources with a path that ends with &quot;.exs&quot; .","ref":"Recode.Project.html#count/2","title":"Recode.Project.count/2","type":"function"},{"doc":"Creates a %Project{} from the given sources.","ref":"Recode.Project.html#from_sources/1","title":"Recode.Project.from_sources/1","type":"function"},{"doc":"Returns true if any source has one or more issues.","ref":"Recode.Project.html#issues?/1","title":"Recode.Project.issues?/1","type":"function"},{"doc":"Return a %Project{} where each source is the result of invoking fun on each source of the given project . The optional opts becomes the second argument of fun . The fun must return {:ok, source} to update the project or :error to skip the update of the source .","ref":"Recode.Project.html#map/3","title":"Recode.Project.map/3","type":"function"},{"doc":"Creates a %Project{} from the given inputs . The inputs can also contain wildcards. Examples iex&gt; alias Recode.Project","ref":"Recode.Project.html#new/1","title":"Recode.Project.new/1","type":"function"},{"doc":"Saves all sources in the project to disk. This function call Recode.Source.save/1 on all sources in the project . The optional second argument accepts a list of paths for files to be excluded.","ref":"Recode.Project.html#save/2","title":"Recode.Project.save/2","type":"function"},{"doc":"Same as source/2 but raises on error.","ref":"Recode.Project.html#source!/2","title":"Recode.Project.source!/2","type":"function"},{"doc":"Returns a %Source{} for the given key . The key could be a path or an id. For path keys, the most recent file is returned. Examples iex&gt; source = Source . from_string ( ...&gt; &quot;&quot;&quot; ...&gt; defmodule MyApp.Mode do ...&gt; end ...&gt; &quot;&quot;&quot; , ...&gt; &quot;my_app/mode.ex&quot; ...&gt; ) iex&gt; project = Project . from_sources ( [ source ] ) iex&gt; Project . source ( project , &quot;my_app/mode.ex&quot; ) { :ok , source } iex&gt; Project . source ( project , source . id ) { :ok , source } iex&gt; Project . source ( project , &quot;foo&quot; ) :error iex&gt; source = Source . from_string ( &quot;:a&quot; , &quot;a.ex&quot; ) iex&gt; project = Project . from_sources ( ...&gt; [ source , Source . from_string ( &quot;:b&quot; , &quot;b.ex&quot; ) ] ...&gt; ) iex&gt; update = Source . update ( source , :test , path : &quot;b.ex&quot; ) iex&gt; project = Project . update ( project , update ) iex&gt; Project . source ( project , &quot;a.ex&quot; ) { :ok , update } iex&gt; Project . source ( project , &quot;b.ex&quot; ) { :ok , update }","ref":"Recode.Project.html#source/2","title":"Recode.Project.source/2","type":"function"},{"doc":"Returns all sources sorted by path.","ref":"Recode.Project.html#sources/1","title":"Recode.Project.sources/1","type":"function"},{"doc":"Returns the unreferenced sources. Unreferenced source are sources whose original path is no longer part of the project.","ref":"Recode.Project.html#unreferenced/1","title":"Recode.Project.unreferenced/1","type":"function"},{"doc":"Updates the project with the given source . If the source is part of the project the source will be replaced, otherwise the source will be added.","ref":"Recode.Project.html#update/2","title":"Recode.Project.update/2","type":"function"},{"doc":"","ref":"Recode.Project.html#t:id/0","title":"Recode.Project.id/0","type":"type"},{"doc":"","ref":"Recode.Project.html#t:t/0","title":"Recode.Project.t/0","type":"type"},{"doc":"A representation of some source in a project. The %Source{} contains the code of the file given by path . The module contains Source.update/3 to update the path and/or the code . The changes are recorded in the updates list. The struct also holds issues for the source.","ref":"Recode.Source.html","title":"Recode.Source","type":"module"},{"doc":"Adds the given issue to the source .","ref":"Recode.Source.html#add_issue/2","title":"Recode.Source.add_issue/2","type":"function"},{"doc":"Adds the given issues to the source .","ref":"Recode.Source.html#add_issues/2","title":"Recode.Source.add_issues/2","type":"function"},{"doc":"Returns the AST for the given %Source . The returned extended AST is generated with Sourceror.parse_string/1 . Uses the current code of the source . Examples iex&gt; &quot;def foo, do: :foo&quot; |&gt; Source . from_string ( ) |&gt; Source . ast ( ) { :def , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 1 ] , [ { :foo , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 5 ] , nil } , [ { { :__block__ , [ trailing_comments : [ ] , leading_comments : [ ] , format : :keyword , line : 1 , column : 10 ] , [ :do ] } , { :__block__ , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 14 ] , [ :foo ] } } ] ] }","ref":"Recode.Source.html#ast/1","title":"Recode.Source.ast/1","type":"function"},{"doc":"Returns the current code for the given source .","ref":"Recode.Source.html#code/1","title":"Recode.Source.code/1","type":"function"},{"doc":"Returns the code of a source for the given version . Examples iex&gt; bar = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; def bar, do: :bar ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; foo = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; source = Source . from_string ( bar ) iex&gt; source = Source . update ( source , :example , code : foo ) iex&gt; Source . code ( source ) == foo true iex&gt; Source . code ( source , 2 ) == foo true iex&gt; Source . code ( source , 1 ) == bar true","ref":"Recode.Source.html#code/2","title":"Recode.Source.code/2","type":"function"},{"doc":"Compares the path values of the given sources. Examples iex&gt; a = Source . from_string ( &quot;:foo&quot; , &quot;a.exs&quot; ) iex&gt; Source . compare ( a , a ) :eq iex&gt; b = Source . from_string ( &quot;:foo&quot; , &quot;b.exs&quot; ) iex&gt; Source . compare ( a , b ) :lt iex&gt; Source . compare ( b , a ) :gt","ref":"Recode.Source.html#compare/2","title":"Recode.Source.compare/2","type":"function"},{"doc":"Same as debug_info/1 but raises on error.","ref":"Recode.Source.html#debug_info!/2","title":"Recode.Source.debug_info!/2","type":"function"},{"doc":"Returns the debug info for the give source and module . Uses the current code of the source . Examples iex&gt; bar = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; def bar, do: :bar ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; bar |&gt; Source . from_string ( ) |&gt; Source . debug_info ( Bar ) { :ok , %{ attributes : [ ] , compile_opts : [ ] , definitions : [ { { :bar , 0 } , :def , [ line : 2 ] , [ { [ line : 2 ] , [ ] , [ ] , :bar } ] } ] , deprecated : [ ] , file : &quot;nofile&quot; , is_behaviour : false , line : 1 , module : Bar , relative_file : &quot;nofile&quot; , struct : nil , unreachable : [ ] } }","ref":"Recode.Source.html#debug_info/2","title":"Recode.Source.debug_info/2","type":"function"},{"doc":"Marks the given source as deleted. This function set the path of the given source to nil .","ref":"Recode.Source.html#del/2","title":"Recode.Source.del/2","type":"function"},{"doc":"Creates a new %Source{} from the given string . Examples iex&gt; source = Source . from_string ( &quot;a + b&quot; ) iex&gt; source . modules [ ] iex&gt; source . code &quot;a + b&quot;","ref":"Recode.Source.html#from_string/2","title":"Recode.Source.from_string/2","type":"function"},{"doc":"Returns true if the source has issues for the given version . The version argument also accepts :actual and :all to check whether the source has problems for the actual version or if there are problems at all. Examples iex&gt; alias Recode.Issue iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( &quot;some/where/plus.exs&quot; ) ...&gt; |&gt; Source . add_issue ( Issue . new ( :test , &quot;no comment&quot; , line : 1 ) ) ...&gt; |&gt; Source . update ( :example , path : &quot;some/where/else/plus.exs&quot; ) ...&gt; |&gt; Source . add_issue ( Issue . new ( :test , &quot;no comment&quot; , line : 1 ) ) iex&gt; Source . has_issues? ( source ) true iex&gt; Source . has_issues? ( source , 1 ) true iex&gt; Source . has_issues? ( source , :all ) true iex&gt; source = Source . update ( source , :example , code : &quot;a - b&quot; ) iex&gt; Source . has_issues? ( source ) false iex&gt; Source . has_issues? ( source , 2 ) true iex&gt; Source . has_issues? ( source , :all ) true","ref":"Recode.Source.html#has_issues?/2","title":"Recode.Source.has_issues?/2","type":"function"},{"doc":"Returns the current modules for the given source .","ref":"Recode.Source.html#modules/1","title":"Recode.Source.modules/1","type":"function"},{"doc":"Returns the modules of a source for the given version . Examples iex&gt; bar = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; def bar, do: :bar ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; foo = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; source = Source . from_string ( bar ) iex&gt; source = Source . update ( source , :example , code : bar &lt;&gt; foo ) iex&gt; Source . modules ( source ) [ Bar , Foo ] iex&gt; Source . modules ( source , 2 ) [ Bar , Foo ] iex&gt; Source . modules ( source , 1 ) [ Bar ]","ref":"Recode.Source.html#modules/2","title":"Recode.Source.modules/2","type":"function"},{"doc":"Creates a new %Source{} from the given path . Examples iex&gt; source = Source . new! ( &quot;test/fixtures/source/simple.ex&quot; ) iex&gt; source . modules [ MyApp.Simple ] iex&gt; source . code &quot;&quot;&quot; defmodule MyApp.Simple do def foo(x) do x * 2 end end &quot;&quot;&quot;","ref":"Recode.Source.html#new!/1","title":"Recode.Source.new!/1","type":"function"},{"doc":"Returns the current path for the given source .","ref":"Recode.Source.html#path/1","title":"Recode.Source.path/1","type":"function"},{"doc":"Returns the path of a source for the given version . Examples iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( &quot;some/where/plus.exs&quot; ) ...&gt; |&gt; Source . update ( :example , path : &quot;some/where/else/plus.exs&quot; ) ...&gt; Source . path ( source , 1 ) &quot;some/where/plus.exs&quot; iex&gt; Source . path ( source , 2 ) &quot;some/where/else/plus.exs&quot;","ref":"Recode.Source.html#path/2","title":"Recode.Source.path/2","type":"function"},{"doc":"Saves the source to disk. If the source :path was updated then the old file will be deleted. The original file will also deleted when the source was marked as deleted with del/1 . Missing directories are created. Examples iex&gt; &quot;:test&quot; |&gt; Source . from_string ( ) |&gt; Source . save ( ) { :error , :nofile } iex&gt; path = &quot;tmp/foo.ex&quot; iex&gt; File . write ( path , &quot;:foo&quot; ) iex&gt; source = path |&gt; Source . new! ( ) |&gt; Source . update ( :test , code : &quot;:bar&quot; ) iex&gt; Source . save ( source ) :ok iex&gt; File . read ( path ) { :ok , &quot;:bar \\n &quot; } iex&gt; source |&gt; Source . del ( ) |&gt; Source . save ( ) iex&gt; File . exists? ( path ) false iex&gt; source = Source . from_string ( &quot;:bar&quot; ) iex&gt; Source . save ( source ) { :error , :nofile } iex&gt; source |&gt; Source . update ( :test , path : &quot;tmp/bar.ex&quot; ) |&gt; Source . save ( ) :ok iex&gt; path = &quot;tmp/ping.ex&quot; iex&gt; File . write ( path , &quot;:ping&quot; ) iex&gt; source = path |&gt; Source . new! ( ) iex&gt; new_path = &quot;tmp/pong.ex&quot; iex&gt; source |&gt; Source . update ( :test , path : new_path ) |&gt; Source . save ( ) :ok iex&gt; File . exists? ( path ) false iex&gt; File . read ( new_path ) { :ok , &quot;:ping&quot; }","ref":"Recode.Source.html#save/1","title":"Recode.Source.save/1","type":"function"},{"doc":"Updates the code or the path of a source . Examples iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . update ( :example , path : &quot;test/fixtures/new.exs&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;a - b&quot; ) iex&gt; source . updates [ { :code , :example , &quot;a + b&quot; } , { :path , :example , nil } ] iex&gt; source . code &quot;a - b \\n &quot; If the new value equal to the current value, no updates will be added. iex&gt; source = ...&gt; &quot;a = 42&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) iex&gt; source . updates [ { :code , :example , &quot;a = 42&quot; } ]","ref":"Recode.Source.html#update/3","title":"Recode.Source.update/3","type":"function"},{"doc":"Returns true if the source was updated. The optional argument kind specifies whether only :code changes or :path changes are considered. Defaults to :any . Examples iex&gt; source = Source . from_string ( &quot;a = 42&quot; ) iex&gt; Source . updated? ( source ) false iex&gt; source = Source . update ( source , :example , code : &quot;b = 21&quot; ) iex&gt; Source . updated? ( source ) true iex&gt; Source . updated? ( source , :path ) false iex&gt; Source . updated? ( source , :code ) true","ref":"Recode.Source.html#updated?/2","title":"Recode.Source.updated?/2","type":"function"},{"doc":"Returns the version of the given source . The value 1 indicates that the source has no changes.","ref":"Recode.Source.html#version/1","title":"Recode.Source.version/1","type":"function"},{"doc":"Returns a Sourceror.Zipper with the AST for the given %Source .","ref":"Recode.Source.html#zipper/1","title":"Recode.Source.zipper/1","type":"function"},{"doc":"","ref":"Recode.Source.html#t:by/0","title":"Recode.Source.by/0","type":"type"},{"doc":"","ref":"Recode.Source.html#t:id/0","title":"Recode.Source.id/0","type":"type"},{"doc":"","ref":"Recode.Source.html#t:kind/0","title":"Recode.Source.kind/0","type":"type"},{"doc":"","ref":"Recode.Source.html#t:t/0","title":"Recode.Source.t/0","type":"type"},{"doc":"The version of a %Source{} . The version 1 indicates that the source has no changes.","ref":"Recode.Source.html#t:version/0","title":"Recode.Source.version/0","type":"type"},{"doc":"The behaviour for a recode task.","ref":"Recode.Task.html","title":"Recode.Task","type":"behaviour"},{"doc":"Returns the configuration for the given key .","ref":"Recode.Task.html#c:config/1","title":"Recode.Task.config/1","type":"callback"},{"doc":"Applies a task with the given source and opts .","ref":"Recode.Task.html#c:run/2","title":"Recode.Task.run/2","type":"callback"},{"doc":"This module provides utility functions for recode .","ref":"Recode.Utils.html","title":"Recode.Utils","type":"module"},{"doc":"Returns true id value ends with suffix . Both, value and suffix must be lists or module aliases. Examples iex&gt; Recode.Utils . ends_with? ( Foo.Bar , Bar ) true iex&gt; Recode.Utils . ends_with? ( Foo , Foo.Bar ) false iex&gt; Recode.Utils . ends_with? ( Foo.Bar , Baz ) false iex&gt; Recode.Utils . ends_with? ( [ 1 , 2 , 3 ] , [ 2 , 3 ] ) true iex&gt; Recode.Utils . ends_with? ( [ 1 , 2 , 3 ] , [ 2 , 9 ] ) false","ref":"Recode.Utils.html#ends_with?/2","title":"Recode.Utils.ends_with?/2","type":"function"},{"doc":"Multi aliases makes module uses harder to search for in large code bases. # preferred alias Module.Foo alias Module.Bar # not preferred alias Module . { Foo , Bar } This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.AliasExpansion.html","title":"Recode.Task.AliasExpansion","type":"module"},{"doc":"Alphabetically sorted lists are easier to read. # preferred alias Alpha alias Bravo alias Delta . { Echo , Foxtrot } # not preferred alias Delta . { Foxtrot , Echo } alias Alpha alias Bravo","ref":"Recode.Task.AliasOrder.html","title":"Recode.Task.AliasOrder","type":"module"},{"doc":"This task runs the Elixir formatter. This task runs as first task by any mix recode call.","ref":"Recode.Task.Format.html","title":"Recode.Task.Format","type":"module"},{"doc":"Add parentheses to one-arity functions. # preferred some_string |&gt; String . downcase ( ) |&gt; String . trim ( ) # not preferred some_string |&gt; String . downcase |&gt; String . trim This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.PipeFunOne.html","title":"Recode.Task.PipeFunOne","type":"module"},{"doc":"Pipes ( |&gt; ) should only be used when piping data through multiple calls. # preferred some_string |&gt; String . downcase ( ) |&gt; String . trim ( ) Enum . reverse ( some_enum ) # not preferred some_enum |&gt; Enum . reverse ( ) This task rewrites the code when mix recode runs with autocorrect: true .","ref":"Recode.Task.SinglePipe.html","title":"Recode.Task.SinglePipe","type":"module"},{"doc":"Function should have specs. Options :only - :public , :visible :macros - when true , macros are also checked, Defaults to false .","ref":"Recode.Task.Specs.html","title":"Recode.Task.Specs","type":"module"},{"doc":"Tests must be in a file with the extension *_test.exs . This module searches for *_test.ex to rename the file and/or report an issue.","ref":"Recode.Task.TestFileExt.html","title":"Recode.Task.TestFileExt","type":"module"},{"doc":"A refactoring task to rename functions. For usage, see mix recode.rename .","ref":"Recode.Task.Rename.html","title":"Recode.Task.Rename","type":"module"},{"doc":"","ref":"Recode.ProjectError.html","title":"Recode.ProjectError","type":"exception"},{"doc":"","ref":"Recode.SourceError.html","title":"Recode.SourceError","type":"exception"}]